Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  AutoCAD LT
  Guppendilter und LayerID's

  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Thema geschlossen  Thema geschlossen!
Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   Guppendilter und LayerID's (464 mal gelesen)
Gora1000
Mitglied
Ingenieur


Sehen Sie sich das Profil von Gora1000 an!   Senden Sie eine Private Message an Gora1000  Schreiben Sie einen Gästebucheintrag für Gora1000

Beiträge: 21
Registriert: 21.08.2013

erstellt am: 26. Okt. 2019 08:06    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


2019-10-2607_54_30-AutodeskAutoCAD2019-layer_auslesen.dwg.png


Debugger.png


layer_auslesen.dwg

 
Morgen Zusammen,

ich versuche schon seit einiger Zeit die Layernamen aus den Gruppefiltern im Layermanager mit Autocad 2019 auszulesen. Einen Beitrag habe ich dazu hier:
https://ww3.cad.de/foren/ubb/Forum259/HTML/002244.shtml
gefunden. Allerdings funktioniert es nicht so wie im Beitrag zum Schluss beschrieben. Das Problem liegt aus meiner Sicht an Xrecord welcher die LayerId's zurückgeben sollte. Das erläutere ich etwas später.

Zuerst: Ich verwende folgendes Beispiel:

Code:
Sub readfilter()
        Dim oDict As AcadDictionary
        Dim TrackingoDict As AcadDictionary
        Dim LayFlt As Variant
        Dim oXrec As AcadXRecord
        Dim strLayer As String
        Dim objLayer As AcadLayer
        Dim DataLayer As String
        Dim ArraySize As Long
        Set oDict = ThisDrawing.Layers.GetExtensionDictionary("ACLYDICTIONARY")
        'Set oDict = ThisDrawing.Layers.GetExtensionDictionary("ACAD_LAYERFILTERS")
        Set TrackingoDict = oDict
On Error Resume Next
    For Each LayFlt In oDict
            Set oXrec = TrackingoDict.GetObject(LayFlt.Name)
            Dim z As String
            z = ThisDrawing.Utility.GetObjectIdString(LayFlt, False)
            oXrec.GetXRecordData xtype, XValue
        For i = 3 To UBound(XValue)
            DataLayer = XValue(i)(0)
            Set objLayer = ThisDrawing.ObjectIdToObject(DataLayer)
        Next
    Next LayFlt
End Sub


Die DWG-Datei ist im Anhang.
Lässt man nun den Debugger laufen (Dabei wie im Beitrag unter der oben erwähnten URL beschieben "Alle" filter aktiviert) und schaut sich die Ergebnisse von XValue an, dann sehen wir, dass der Gruppenfilter erkannt wird und es zwei weitere Einräge in XValue gibt, die die LayerID' ethalten sollen. In der Codezeile
Code:
Set objLayer = ThisDrawing.ObjectIdToObject(DataLayer)
wird versucht das Layerobjekt abzugreifen. Das Ergebniss ist allerdings Nothing. Die Zahlen, die in XValue enthalten sind, sind auch negative Zahlen. Die Id's sollten aus meiner Sicht die Form und die Länge, wie die Variable z haben.

Ich hoffe ich konnte das Problem soweit verständlich erläutern und es hat evtl. der eine oder andere einen Tipp für mich.

[Diese Nachricht wurde von Gora1000 am 26. Okt. 2019 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 19656
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 26. Okt. 2019 08:59    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Gora1000 10 Unities + Antwort hilfreich

Das solltest du im Adesk/VBA Forum posten und nicht in LT, LT hat nicht mal eine Programmierschnittstelle.


CAD.de Autodesk Bretter - Klick!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Gora1000
Mitglied
Ingenieur


Sehen Sie sich das Profil von Gora1000 an!   Senden Sie eine Private Message an Gora1000  Schreiben Sie einen Gästebucheintrag für Gora1000

Beiträge: 21
Registriert: 21.08.2013

erstellt am: 26. Okt. 2019 09:12    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hopla,

wie kann ich denn den Beitrag hier löschen?

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP



Technischer Systemplaner, Technischer Zeichner ElektrotechnikTechniker, Meister, Ingenieur Elektrotechnik (m/w/d)

Wir sind ein erfahrenes und unabhängiges Ingenieurbüro für die Planung und Fachbauleitung elektrotechnischer Gebäudeausrüstung und Förderanlagen. Hierbei sind wir im Hotel-, Gastronomie- und Verwaltungsgebäudebau genauso wie im Schul-, Sportstätten-, Bäder- und Wohnbau erfolgreich tätig.

Für unser Büro im Münchner Osten, suchen wir Sie als

Technischer Systemplaner, Technischer ...

Anzeige ansehenTechnischer Zeichner, Bauzeichner
cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 19656
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 26. Okt. 2019 09:18    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Gora1000 10 Unities + Antwort hilfreich

Hier gehts weiter im VBA Forum
https://ww3.cad.de/foren/ubb/Forum259/HTML/002266.shtml

Hier wird nun geschlossen, das reicht.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag öffnen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2020 CAD.de | Impressum | Datenschutz